/*
 * Kirigamibot : move a folding paper with Arduino and a Servo 9gr
 * For a workshop about Animabots
 * Made by http://reso-nance.org
 *
 */

include <MCAD/involute_gears.scad>
include <MCAD/2Dshapes.scad>

$fn=30;

// ------------------- OBJETS ------------------ //

// -------- Fixation papier
//rotate([0,0,90]) fixation_papier(); 

// --------- Bras n°1 : moteur

difference() {
	roue_bras(4);
	translate([0,7.5,0]) rotate([0,0,-17]) palonnier();
	translate([50,2,0]) cylinder(h=4,r=1.5);
}


// -------- Bras n°2
union() {
	difference() {
		mirror([0,1,0]) translate([0,5,0]) roue_bras(4,18);
		//translate([0,-12.5,-1]) cylinder(h=8,r=1.5);
		translate([50,-7,0]) cylinder(h=4,r=1.5);
		linear_extrude(height = 4) mirror([0,0,0]) translate([-0.42,-12.5,0]) donutSlice(6.1,10,-40,40);
	}
	linear_extrude(height = 4) mirror([0,1,0]) translate([5,5,0]) donutSlice(6,10,0,90);
}


//raccord();
//rotate([180,0,0]) translate([7,-16,-4]) fixation_papier();
//fixation_papier3();
//fixation_papier2();

// ------------------- MODULE ------------------ //
module roue_bras (thick,rotationZ=0) {
	//translate([0,7.5,0]) circle(r=7.5);
		union() {
			translate([0,7.5,0]) rotate([0,0,rotationZ])
			gear (number_of_teeth=10, circular_pitch=265, pressure_angle=5,gear_thickness = thick,rim_thickness = thick,hub_thickness = thick, circles=0,bore_diameter=3);

			linear_extrude(height = thick) translate([5,0,0]) donutSlice(6,10,0,90);
			//linear_extrude(height = thick) translate([0,7.33,0]) donutSlice(3.95,9.1,33,112);
			translate([12,0,0]) cube([38,4,4]);
			translate([50,2,0]) cylinder(h=4,r=3);
			//translate([50,0,0]) rotate([0,-90,0]) cube([10,4,12]);
		}
}

module rotule () {
		union() {
			cylinder(h=2,r=3);
			translate([0,0,2]) cylinder(h=8.4,r=1.3);
			translate([0,0,10.4]) cylinder(h=2,r=3);
		}
}


module palonnier(){
union() {
	cylinder(h=4,r=3.75);
	translate([0,0,2.5]) linear_extrude(height=1.5) polygon([[3,0],[-3,0],[-2,11],[2,11]]);
	translate([0,11,2.5]) cylinder(h=1.5,r=2);
	}
}

module raccord () {
	difference() {
		union() {
			cylinder(h=4,r=3);
			translate([2,-2,0]) cube([12,4,4]);
			translate([14,0,0]) cylinder(h=4,r=3);
		}
		cylinder(h=4,r=1.5);
		translate([14,0,0]) cylinder(h=4,r=1.5);
	}
}

module fixation_papier() {
difference() {
	union() {
		translate([-2,4,0]) cube([4,4,4]);
		translate([0,8,0]) rotate([0,0,90])cylinder(h=4,r=3);// avant y=8
		translate([-9,1,-4.5]) cube([18,3,8.5]);

		//translate([-9,-5,1]) cube([3,6,3]);
		//translate([6,-5,1]) cube([3,6,3]);
	}
	translate([0,8,0]) cylinder(h=4,r=1.5);
	}
}



module fixation_papier3() {
difference() {
	union() {
		translate([-2,0,-20]) cube([4,3,40]);
		translate([-2,3,-2]) cube([4,4,4]);
		translate([0,7,-2]) rotate([0,0,90]) cylinder(h=4,r=3);// avant y=8
		
	}
	translate([0,7,-2]) cylinder(h=4,r=1.5);
	}
}

module fixation_papier2() {
fix_w=20;
difference() {
	union() {
	translate([-fix_w/2,0,0]) cube([fix_w,3,10]);
	hull() {
   		translate([10,6,0]) cylinder(h=4,r=3.1);
   		translate([-10,6,0])	cylinder(h=4,r=3.1);
 	}

	}
	hull() {
   		translate([10,6,0]) cylinder(h=4,r=1.55);
   		translate([-10,6,0])	cylinder(h=4,r=1.55);
 	}
	translate([0,4,7.5]) rotate([90,0,0]) cylinder(h=5,r=1);
}
}